import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGatePassreord, ThinkGatePassreordParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkGatePassreord(params: ThinkGatePassreordParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGatePassreord>>>(
    THINK_API_URL + '/think/think-gate-passreord/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkGatePassreord(params?: ThinkGatePassreordParam) {
  const res = await request.get<ApiResult<ThinkGatePassreord[]>>(
    THINK_API_URL + '/think/think-gate-passreord',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkGatePassreord(data: ThinkGatePassreord) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate-passreord',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkGatePassreord(data: ThinkGatePassreord) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate-passreord',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkGatePassreord(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate-passreord/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkGatePassreord(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate-passreord/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkGatePassreord(id: number) {
  const res = await request.get<ApiResult<ThinkGatePassreord>>(
    THINK_API_URL + '/think/think-gate-passreord/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
